//erstellt von Harun Faizi am 01.11.2025
#include "input.h"
#include <string.h>
#include <ctype.h>

// TODO:
// eine Funktion implementieren, die ein einzelnes Wort aus einer Textdatei (words.txt) einliest und als C-String zurückgibt.

/* Liest Wörter aus words.txt und speichert sie in ein 2D-Array "words"
   Trennzeichen: Komma, Semikolon, Leerzeichen und Zeilenumbruch

   file: geöffnete Datei (words.txt)
   words: 2D-Array zu Speicherung der Wörter
   maxWordCount: maximale Anzahl an Wörter, die eingelesen dürfen

   Rückgabe: Anzahl der eingelesen Wörter (0 falls nichts gelesen oder Fehler)
*/

// Read words from file and store in 'words' array
int readWords(FILE *file, char words[][MAX_WORD_LEN], unsigned int maxWordCount)
{         //Gibt die Anzahl der eingelesen Wörter zurück (wordCount), für main wie viel gelesen wurde
          //FILE *file: Zeiger auf Datei --> FILE komplexes Objekt, müssen mit Adresse arbeiten
          //Wort = String = Array von Zeichen (char) --> Zeilen: Wörteranzahl und Spalten: Buchstaben der Wörter
          //wie viele Wörter max in Array geschrieben werden dürfen


   if (file == 0)
      return 0; //Sicherheitsprüfung

   char line[MAX_LINE_LEN]; // Puffer für eine Zeile aus Datei
   unsigned int wordCount = 0; // zählt wie viele Wörter gefunden wurden

   //Lese Datei Zeile für Zeile
   while(fgets(line, sizeof(line), file) != NULL)
   {
         // Zerlege die Datei in einzelne Wörter
         char *token = strtok(line, ".,;\n\t");

         while (token != NULL && wordCount < maxWordCount)
         {
               //aktuelles Wort in Array kopieren
               strncpy(words[wordCount], token, MAX_WORD_LEN -1);
               words[wordCount][MAX_WORD_LEN -1] = '\0';

               wordCount++;
               token = strtok(NULL, ",;\n");
         }
         // Wenn max Wortzahl erreicht ist abbrechen!
         if (wordCount >= maxWordCount)
            break;
   }

   return wordCount;
}




